﻿
using System;
using System.Collections.Generic;
using System.Linq;
using NLite.Data;
namespace NLite.Data.CodeGenerationDemo
{
	using NLite.Reflection;

	public partial class NorthwindContex:DbContext
	{
		//连接字符串名称：基于Config文件中连接字符串的配置
        const string connectionStringName = "Northwind";

        //构造dbConfiguration 对象
        static DbConfiguration dbConfiguration;

		static NorthwindContex()
		{
			 dbConfiguration = DbConfiguration
                  .Configure(connectionStringName)
                  .SetSqlLogger(() =>SqlLog.Debug)
				  .AddFromAssemblyOf<NorthwindContex>(t=>t.HasAttribute<TableAttribute>(false))
				  ;
		}

		public NorthwindContex():base(dbConfiguration){}
		
		public IDbSet<Supplier> Suppliers { get; private set; }
		public IDbSet<Category> Categories { get; private set; }
		public IDbSet<Order> Orders { get; private set; }
		public IDbSet<Employee> Employees { get; private set; }
		public IDbSet<Customer> Customers { get; private set; }
		public IDbSet<OrderDetail> OrderDetails { get; private set; }
		public IDbSet<Product> Products { get; private set; }
		public IDbSet<CustomerDemographic> CustomerDemographics { get; private set; }
		public IDbSet<EmployeeTerritory> EmployeeTerritories { get; private set; }
		public IDbSet<Shipper> Shippers { get; private set; }
		public IDbSet<Territory> Territories { get; private set; }
		public IDbSet<Region> Regions { get; private set; }
		public IDbSet<CustomerCustomerDemo> CustomerCustomerDemos { get; private set; }
		public IDbSet<OrderDetailsExtended> OrderDetailsExtendeds { get; private set; }
		public IDbSet<ProductsByCategory> ProductsByCategories { get; private set; }
		public IDbSet<Invoice> Invoices { get; private set; }
		public IDbSet<SummaryOfSalesByYear> SummaryOfSalesByYears { get; private set; }
		public IDbSet<OrdersQry> OrdersQries { get; private set; }
		public IDbSet<SalesByCategory> SalesByCategories { get; private set; }
		public IDbSet<CustomerAndSuppliersByCity> CustomerAndSuppliersByCities { get; private set; }
		public IDbSet<AlphabeticalListOfProduct> AlphabeticalListOfProducts { get; private set; }
		public IDbSet<QuarterlyOrder> QuarterlyOrders { get; private set; }
		public IDbSet<SummaryOfSalesByQuarter> SummaryOfSalesByQuarters { get; private set; }
		public IDbSet<SalesTotalsByAmount> SalesTotalsByAmounts { get; private set; }
		public IDbSet<CurrentProductList> CurrentProductLists { get; private set; }
		public IDbSet<CategorySalesFor1997> CategorySalesFor1997s { get; private set; }
		public IDbSet<ProductSalesFor1997> ProductSalesFor1997s { get; private set; }
		public IDbSet<OrderSubtotal> OrderSubtotals { get; private set; }
		public IDbSet<ProductsAboveAveragePrice> ProductsAboveAveragePrices { get; private set; }
	}
}
